# booleanhelper.rb 1.04
# april 9, 2011
#
# Description: Perform a quick scale up on a small model to do boolean or lathe operations.
# This is usefull since sketchup can not work with very small faces.
# After the operations are finished you can scale your model down to get back to the original dimensions
#
# 
# This plugin was conceived by me, rene van Asperen with great help from TIG  and Thomas from
# the SketchUcation forums.
#
#
# USE OF THIS SOFTWARE IS AT YOUR OWN RISK!
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.




require 'sketchup.rb'

#=============================================================================
	
 class MySelectionObserverBhelper < Sketchup::SelectionObserver
       def onSelectionBulkChange(selection)
	       
		model = Sketchup.active_model
		entities = model.entities
	
	

			if entities[0].class == Sketchup::Text and entities[1] == nil
				
				Sketchup.active_model.set_attribute('Liquid98','multiplier',nil)
				Sketchup.active_model.set_attribute('Liquid98','emptynote','true')
				a = entities[0]
				model.entities.erase_entities(a)
				
			end
			if entities[0].class == Sketchup::Text and entities[1].class == Sketchup::Text
				
				Sketchup.active_model.set_attribute('Liquid98','multiplier',nil)
				Sketchup.active_model.set_attribute('Liquid98','emptynote','true')
				a = entities[0]
				model.entities.erase_entities(a)
			
			end
			
			if entities[0] == nil 
				Sketchup.active_model.set_attribute('Liquid98','multiplier',nil)
				Sketchup.active_model.set_attribute('Liquid98','emptynote','true')
			
				Bhelper::Feedback.new()
			end
			
	end
 end

 Sketchup.active_model.selection.add_observer(MySelectionObserverBhelper.new)


module MyUsefulMethods
  def product
   @foo.inject { |x,y| x*y }
  end
end




module Bhelper

 
 
 
 class Reken
  include MyUsefulMethods
	def initialize
		
	 @foo = Sketchup.active_model.get_attribute('Liquid98','multiplier',nil)
	 
	end
end
	

		





class Getinfo
	def initialize() 
		sf = '100' # Set standard scalefactor if necessary
		a = Sketchup.read_default('liquidsscalefactor','value')
			if  (a != '10' && a != '100' && a != '1000') 
				Sketchup.write_default('liquidsscalefactor','value',sf)
			end
 
		sc = 'Origin' # Set standard scale about option if necessary
		b = Sketchup.read_default('liquidsscalefactor','scale')
			if  (b != 'Origin' && b != 'Objects center') 
				Sketchup.write_default('liquidsscalefactor','scale',sc)
			end
		
		@@sf = Sketchup.read_default('liquidsscalefactor','value','100')
		@@scntr = Sketchup.read_default('liquidsscalefactor','scale','Origin')
		
		prompts = ["Set scalefactor   ", "Scale about"]
		defaults = [@@sf, @@scntr]
		values = ["10|100|1000", "Origin|Objects center"]  		# For other scale factors please use the native Sketchup-scale tool . This script is intended only for quick scale up and down actions .
		results = UI.inputbox prompts, defaults, values, "Scalefactor."
	 return if not results
		@@sf = results[0]
		Sketchup.write_default('liquidsscalefactor','value',@@sf)
		@@scntr = results[1]
		Sketchup.write_default('liquidsscalefactor','scale',@@scntr)
	
		Bhelper::Tltip.new()
	end
end


	


class Groter
	def initialize() 
	 sf = (Sketchup.read_default 'liquidsscalefactor', 'value', '100').to_f
	 model = Sketchup.active_model
	 entities = model.entities
		return if entities[0] == nil 		# Test if the scene is empty, otherwise screennotes ar writen to it without any real scaling action
		




sc = Sketchup.read_default('liquidsscalefactor','scale','Origin')
		 
		 
		
		if sc =='Origin'
		@@center = [0, 0, 0]
		else
		
	
		boundbox = model.bounds
		@@center= boundbox.center 
		
		end

	







         trans = Geom::Transformation.scaling(@@center, sf)
	 entities.transform_entities(trans, entities.to_a)
	 Sketchup.active_model.active_view.zoom_extents

	 
	 
	 @@sforg = Sketchup.active_model.get_attribute('Liquid98','multiplier',nil)
	 
	 @@sfnew = @@sforg.to_a << sf.to_i
	 
	 Sketchup.active_model.set_attribute('Liquid98','multiplier',@@sfnew)

	 
	 
	 
	 
	 
	 
	 
	 Bhelper::Feedback.new()
	
	end
end




class Kleiner
	def initialize() 
		@@sforg = Sketchup.active_model.get_attribute('Liquid98','multiplier',nil)
		if @@sforg == nil
		 UI.messagebox "Scale up your model first, and and then use the 'Scaledown at once' button"
		else
		 tt = Bhelper::Reken.new.product 
		end
		 	 model = Sketchup.active_model
			entities = model.entities
		 
		 sc = Sketchup.read_default('liquidsscalefactor','scale','Origin')
		
	
		 
		if sc =='Origin'
		@@center = [0, 0, 0]
		else
		
	
		boundbox = model.bounds
		@@center= boundbox.center 
		
		end

	
			
			
			
			
			
	
	
	 trans = Geom::Transformation.scaling(@@center, 1.0/tt)
	 entities.transform_entities(trans, entities.to_a)
	 Sketchup.active_model.active_view.zoom_extents
	 Sketchup.active_model.set_attribute('Liquid98','multiplier',nil)
	 
	 Bhelper::Feedback.new() 
	end
end









class Tltip
	def initialize()
	 a = Sketchup.read_default('liquidsscalefactor','value', '100')
		if a.class ==String
		 a=a.to_f
		else ### might be an Array or something else!
		 a=100.0
		end#if
	 $cmdbooleanhelperscale.tooltip = ("Scale down at once") if $cmdbooleanhelperscale
	 $cmdbooleanhelperscale1.tooltip = ("Scale up with factor #{a.to_i}") if $cmdbooleanhelperscale1
	end
end


class Feedback
	def initialize()
		@@sforg = Sketchup.active_model.get_attribute('Liquid98','multiplier',nil)
		@@bug = Sketchup.active_model.get_attribute('Liquid98','emptynote',nil)
		
		
	         model = Sketchup.active_model
		 entities = model.active_entities
		
		if @@bug == 'false'
		   @@note.erase!
		end
			
		if @@sforg.to_a == []   
		
			 @@notetext = "   "
		
		end
		
		if @@sforg.to_a != []
			tt = Bhelper::Reken.new.product.to_i
			@@notetext = "Scaled up #{tt} times"
		
		end
	
	
		@@note = Sketchup.active_model.add_note @@notetext, 0.01, 0.99
		Sketchup.active_model.set_attribute('Liquid98','emptynote','false')
		
	       
		 


	
		
		
	 end
end
#=============================================================================
if( not $booleanhelper_menu_loaded )
	
	add_separator_to_menu("Plugins")
        new_menu = UI.menu("Plugins").add_submenu("Boolean helper")
        new_toolbar = UI::Toolbar.new("Boolean helper")
        plugins = Sketchup.find_support_file("Plugins")
	
        imgdir = File.join(plugins, "Booleanhelper")

        $cmdbooleanhelperscale = UI::Command.new("Scale down at once") {Bhelper::Kleiner.new() }
	$cmdbooleanhelperscale.small_icon = File.join(imgdir, "smaller.png")
        $cmdbooleanhelperscale.large_icon = File.join(imgdir, "smallerL.png")
	
        

		new_menu.add_item($cmdbooleanhelperscale)
		new_toolbar.add_item($cmdbooleanhelperscale)
		
	$cmdbooleanhelperscale1= UI::Command.new("Scale up") {Bhelper::Groter.new() }
	$cmdbooleanhelperscale1.small_icon = File.join(imgdir, "bigger.png")
        $cmdbooleanhelperscale1.large_icon = File.join(imgdir, "biggerL.png")
	


		new_menu.add_item($cmdbooleanhelperscale1)
		new_toolbar.add_item($cmdbooleanhelperscale1)
    
	cmd = UI::Command.new("set scale factor") {Bhelper::Getinfo.new()}
	
		new_menu.add_item(cmd)
		new_toolbar.show
Bhelper::Tltip.new()
        $booleanhelper_menu_loaded = true
end#if

end #module




